
module Dictionnaire(Dictionnaire,creer,rechercherCle,inserer,insererM,tailleReelle,taille,insererIntervalle,insererIntervalleM,insererListe,insererListeM,supprimer,supprimerM,rechercherParCle,mapDico,filter) where

 
-- Arbre Binaire de Recherche par Intervalles
data Dictionnaire cle val  = StructureDeDonneeACompleter




-- Creer un arbre vide
creer :: Dictionnaire cle val
creer = undefined

-- Rechercher une clef dans les intervalles de l'arbre
rechercherCle :: Ord cle =>
	         Dictionnaire cle val -> cle -> Bool
rechercherCle = undefined

-- Inserer une clef avec son contexte en modifiant potentielement les intervalles
-- Non definit si conflit de valeur
inserer :: (Ord cle, Enum cle, Eq val) =>
	   Dictionnaire cle val -> cle -> val -> Dictionnaire cle val
inserer = undefined

-- Insersion qui retourne Nothing si conflit de valeur
insererM :: (Ord cle, Enum cle, Eq val) =>
	    Dictionnaire cle val -> cle -> val -> Maybe (Dictionnaire cle val)
insererM = undefined

-- Imprimer mon arbre
instence (Show cle, Show val) => Show (Dictionnaire cle val) where
  show = undefined

-- Somme des longueurs de tous les intervalles
tailleReelle :: (Enum cle) =>
	        Dictionnaire cle val -> Int
tailleReelle = undefined

-- Nombre de noeuds
taille :: Dictionnaire cle val -> Int
taille = undefined

-- Inserer tout un interval de clefs pour un context, peut renvoyer Nothing en cas de conflits sur les contenus
insererIntervalle :: (Ord cle, Enum cle, Eq val) =>
	             Dictionnaire cle val -> cle -> cle -> val -> Dictionnaire cle val
insererIntervalle = undefined

-- Version sur avec Maybe
insererIntervalleM :: (Ord cle, Enum cle, Eq val) =>
	             Dictionnaire cle val -> cle -> cle -> val -> Maybe (Dictionnaire cle val)
insererIntervalle = undefined

-- Insertion d'une liste de clefs et contexts
insererListe :: (Ord cle, Enum cle, Eq val) =>
	        Dictionnaire cle val -> [(cle,val)] -> Dictionnaire cle val
insererListe = undefined

-- Version sur avec Maybe
insererListe :: (Ord cle, Enum cle, Eq val) =>
	        Dictionnaire cle val -> [(cle,val)] -> Maybe (Dictionnaire cle val)
insererListe = undefined

-- Suppression d'une clef
supprimer :: (Ord cle, Enum cle, Eq val) =>
	     Dictionnaire cle val -> cle -> Dictionnaire cle val
supprimer = undefined

-- Suppression d'une clef avec resultat Nothing si clef non presente
supprimerM :: (Ord cle, Enum cle, Eq val) =>
	      Dictionnaire cle val -> cle -> Maybe (Dictionnaire cle val)
supprimerM = undefined




-- Rechercher une clef et rendre le contenu trouve, rend Nothing si non trouve
rechercherParCle :: Ord cle =>
	            Dictionnaire cle val -> cle -> Maybe val
rechercherParCle = undefined

-- modifier tous les contenus d'un dictionnaire
mapDico :: (Ord cle, Enum cle, Eq a, Eq b) =>
	   (a->b) ->  Dictionnaire cle a -> Dictionnaire cle b
mapDico = undefined

-- filtrer les contenus d'un dictionnaire
filtrer :: (Ord cle, Enum cle, Eq val) =>
	   (val->Bool) ->  Dictionnaire cle val -> Dictionnaire cle val
filtrer = undefined
